package fastmode;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import NTPortJava.*;
import java.awt.Dimension;
import java.awt.Rectangle;


/**
 * <p>Title: NTPort Library</p>
 * <p>Description: Fast Mode Sample</p>
 * <p>Copyright: Copyright (c) 2006 Zeal SoftStudio</p>
 * <p>Company: Zeal SoftStudio</p>
 * @author Hai Li
 * @version 1.1
 */

public class Frame1 extends JFrame {
  JPanel contentPane;
  JLabel jLabel1 = new JLabel();
  JTextField jTextField1 = new JTextField();
  JLabel jLabel2 = new JLabel();
  JTextField jTextField2 = new JTextField();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JButton btnFast = new JButton();
  JButton btnNormal = new JButton();
  JLabel jLabel5 = new JLabel();

  //Construct the frame
  public Frame1() {
    // After register NTPort Library,
    // place your registration information here.
    NTPortJava.LicenseInfo("Your Name", 0);

    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    jLabel1.setText("I/O Address:");
    jLabel1.setBounds(new Rectangle(16, 23, 79, 21));
    contentPane.setLayout(null);
    this.setSize(new Dimension(400, 188));
    this.setContentPane(contentPane);
    this.setTitle("Fast Mode Sample");
    jTextField1.setText("200");
    jTextField1.setBounds(new Rectangle(84, 24, 41, 19));
    jTextField1.addActionListener(new Frame1_jTextField1_actionAdapter(this));
    jLabel2.setText("Times:");
    jLabel2.setBounds(new Rectangle(131, 24, 51, 21));
    jTextField2.setText("1000");
    jTextField2.setBounds(new Rectangle(166, 22, 56, 24));
    jLabel3.setText("Click the \"Fast Mode\" button to test!");
    jLabel3.setBounds(new Rectangle(13, 49, 249, 21));
    jLabel4.setText("Click the \"Normal Mode\" button to test!");
    jLabel4.setBounds(new Rectangle(13, 83, 251, 22));
    btnFast.setBounds(new Rectangle(277, 48, 108, 23));
    btnFast.setText("Fast Mode");
    btnFast.addActionListener(new Frame1_btnFast_actionAdapter(this));
    btnNormal.setText("Normal Mode");
    btnNormal.setBounds(new Rectangle(277, 82, 107, 23));
    btnNormal.addActionListener(new Frame1_btnNormal_actionAdapter(this));
    jLabel5.setText("Copyright (c) 1997-2006 Hai Li, Zeal SoftStudio.");
    jLabel5.setBounds(new Rectangle(13, 116, 377, 21));
    contentPane.add(jLabel1, null);
    contentPane.add(jTextField1, null);
    contentPane.add(jLabel2, null);
    contentPane.add(jTextField2, null);
    contentPane.add(jLabel4, null);
    contentPane.add(btnFast, null);
    contentPane.add(jLabel5, null);
    contentPane.add(btnNormal, null);
    contentPane.add(jLabel3, null);
  }
  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void jTextField1_actionPerformed(ActionEvent e) {

  }

  void btnFast_actionPerformed(ActionEvent e) {
    StringBuffer sz = new StringBuffer(255);
    int i, nData;

    // Check the OS
    if(!NTPortJava.IsWinNT())
    {
            JOptionPane.showMessageDialog(this,
                "Fast mode is designed for Windows NT/2000/XP/Server 2003, not Windows 95/98.",
                "Notice", JOptionPane.INFORMATION_MESSAGE);
            return;
    }

    if(NTPortJava.IsWin64())
    {
            JOptionPane.showMessageDialog(this,
                "Fast mode is not supported in x64 edition!",
                "Notice", JOptionPane.INFORMATION_MESSAGE);
            return;
    }

    // Get the address of the port
    short nAddress = Integer.valueOf(jTextField1.getText()).shortValue();
    short nTimes = Integer.valueOf(jTextField2.getText()).shortValue();

    // Use fast mode
    NTPortJava.SetFastMode(true);

    // To use the fast mode, you must call EnablePorts
    // before you call the Inport, Outport, and other
    // functions.
    NTPortJava.EnablePorts(nAddress, nAddress);

    // Test the result of EnablePorts
    if(NTPortJava.GetLastState(sz) != NTPortJava.ERROR_NONE)
    {
        JOptionPane.showMessageDialog(this, sz.toString(),
                                      "Error", JOptionPane.ERROR_MESSAGE);
        return;
    }

    // If you are using Evaluation version, this
    // statement will show the registration reminder
    // dialog. If you are using the registered version,
    // please call LicesnseInfo instead.
    nData = NTPortJava.Inp(nAddress);

    // Start the time count
    double dfTime = NTPortJava.GetHiResTime();

    // Read the port in a loop
    for( i = 1; i < nTimes; i++)
        nData = NTPortJava.Inp(nAddress);

    // Stop the time count
    dfTime = NTPortJava.GetHiResTime() - dfTime;

    // Free the resource
    NTPortJava.DisablePorts(nAddress, nAddress);

    String s;
    s = "Fast mode time cost: " + String.valueOf(dfTime) + "ms";
    // Show the result
    jLabel3.setText(s);

  }

  void btnNormal_actionPerformed(ActionEvent e) {
    StringBuffer sz = new StringBuffer(255);
    int i, nData;

    // Get the address of the port
    short nAddress = Integer.valueOf(jTextField1.getText()).shortValue();
    short nTimes = Integer.valueOf(jTextField2.getText()).shortValue();

    // Use fast mode
    NTPortJava.SetFastMode(false);

    // Test the result of EnablePorts
    if(NTPortJava.GetLastState(sz) != NTPortJava.ERROR_NONE)
    {
        JOptionPane.showMessageDialog(this, sz.toString(),
                                    "Error", JOptionPane.ERROR_MESSAGE);
        return;
    }

    // If you are using Evaluation version, this
    // statement will show the registration reminder
    // dialog. If you are using the registered version,
    // please call LicesnseInfo instead.
    nData = NTPortJava.Inp(nAddress);

    // Start the time count
    double dfTime = NTPortJava.GetHiResTime();

    // Read the port in a loop
    for( i = 1; i < nTimes; i++)
        nData = NTPortJava.Inp(nAddress);

    // Stop the time count
    dfTime = NTPortJava.GetHiResTime() - dfTime;

    String s;
    s = "Normal mode time cost: " + String.valueOf(dfTime) + "ms";
    // Show the result
    jLabel4.setText(s);

  }
}  //  @jve:decl-index=0:visual-constraint="10,10"

class Frame1_jTextField1_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jTextField1_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTextField1_actionPerformed(e);
  }
}

class Frame1_btnFast_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_btnFast_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnFast_actionPerformed(e);
  }
}

class Frame1_btnNormal_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_btnNormal_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnNormal_actionPerformed(e);
  }
}