package lpttest;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import NTPortJava.*;
import java.awt.Rectangle;
import java.awt.Dimension;

/**
 * <p>Title: LPTPort sample</p>
 * <p>Description: LPTPort sample demonstrates how to get the base addresses of LPT ports.</p>
 * <p>Copyright: Copyright (c) 2004 Zeal SoftStudio</p>
 * <p>Company: Zeal SoftStudio</p>
 * @author Hai Li
 * @version 1.0
 */

public class Frame1
    extends JFrame {
  JPanel contentPane;
  JButton jButton1 = new JButton();
  JLabel jLabel1 = new JLabel();
  DefaultListModel model = new DefaultListModel();
  JList jList1 = new JList(model);
  JLabel jLabel2 = new JLabel();

  //Construct the frame
  public Frame1() {
    // After register NTPort Library,
    // place your registration information here.
    NTPortJava.LicenseInfo("Your Name", 0);

    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    contentPane = (JPanel)this.getContentPane();
    jButton1.setBounds(new Rectangle(169, 24, 71, 30));
    jButton1.setText("Get");
    jButton1.addActionListener(new Frame1_jButton1_actionAdapter(this));
    contentPane.setLayout(null);
    this.setSize(new Dimension(262, 230));
    this.setContentPane(contentPane);
    this.setTitle("LPT Test");
    jLabel1.setText("Result:");
    jLabel1.setBounds(new Rectangle(11, 1, 92, 25));
    jLabel2.setText("Copyright (c) 1997-2006 Zeal SoftStudio.");
    jLabel2.setBounds(new Rectangle(10, 172, 257, 18));
    jList1.setBounds(new Rectangle(9, 27, 156, 139));
    contentPane.add(jList1, null);
    contentPane.add(jLabel1, null);
    contentPane.add(jButton1, null);
    contentPane.add(jLabel2, null);
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void jButton1_actionPerformed(ActionEvent e) {
    short i, nAddress;
    int nError;
    String s;

    jList1.removeAll();
    for (i = 1; i <= 3; i++) {
      nAddress = NTPortJava.GetLPTPortAddress(i);
      nError = NTPortJava.GetLastState(null);
      if (nAddress != 0) {
        s = "LPT" + String.valueOf(i) + ": 0x" + Integer.toHexString(nAddress);
      }
      else if (nError != 0) {
        s = "LPT" + String.valueOf(i) + ": Error";
      }
      else {
        s = "LPT" + String.valueOf(i) + ": absent";
      }
      model.addElement(s);
    }

  }
}  //  @jve:decl-index=0:visual-constraint="10,10"

class Frame1_jButton1_actionAdapter
    implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jButton1_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}