package porttest;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import NTPortJava.*;

/**
 * <p>Title: PortTest Sample</p>
 * <p>Description: This sample illustrates how to use NTPort Library to read or write PC I/O ports.</p>
 * <p>Copyright: Copyright (c) 2004 Zeal SoftStudio</p>
 * <p>Company: Zeal SoftStudio</p>
 * @author Hai Li
 * @version 1.0
 */

public class Frame1 extends JFrame {
  JPanel contentPane;
  JLabel jLabel1 = new JLabel();
  JTextField jTextField1 = new JTextField();
  JLabel jLabel2 = new JLabel();
  JTextField jTextField2 = new JTextField();
  JButton btnRead = new JButton();
  JButton btnWrite = new JButton();
  JPanel jPanel1 = new JPanel();
  Border border1;
  JRadioButton jRadioButton1 = new JRadioButton();
  JRadioButton jRadioButton2 = new JRadioButton();
  JRadioButton jRadioButton3 = new JRadioButton();
  JLabel jLabel3 = new JLabel();
  GridLayout gridLayout1 = new GridLayout();
  ButtonGroup buttonGroup1 = new ButtonGroup();
  DefaultListModel model = new DefaultListModel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JList jList1 = new JList();

  //Construct the frame
  public Frame1() {
    // After register NTPort Library,
    // place your registration information here.
    NTPortJava.LicenseInfo("Your Name", 0);

    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    border1 = BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(115, 114, 105),new Color(165, 163, 151));
    jLabel1.setText("Address(Hex):");
    jLabel1.setBounds(new Rectangle(9, 13, 84, 17));
    contentPane.setLayout(null);
    this.setSize(new Dimension(400, 300));
    this.setTitle("PortTest Sample");
    jTextField1.setText("61");
    jTextField1.setBounds(new Rectangle(82, 11, 49, 21));
    jTextField1.addActionListener(new Frame1_jTextField1_actionAdapter(this));
    jLabel2.setBounds(new Rectangle(147, 15, 84, 17));
    jLabel2.setText("Value:");
    jTextField2.setText("0");
    jTextField2.setBounds(new Rectangle(190, 11, 49, 21));
    btnRead.setBounds(new Rectangle(303, 12, 73, 25));
    btnRead.setText("Input");
    btnRead.addActionListener(new Frame1_btnRead_actionAdapter(this));
    btnWrite.setText("Output");
    btnWrite.addActionListener(new Frame1_btnWrite_actionAdapter(this));
    btnWrite.setBounds(new Rectangle(303, 46, 73, 25));
    jPanel1.setBorder(border1);
    jPanel1.setBounds(new Rectangle(10, 194, 275, 32));
    jPanel1.setLayout(gridLayout1);
    jRadioButton1.setSelected(true);
    jRadioButton1.setText("Byte");
    jRadioButton1.addActionListener(new Frame1_jRadioButton1_actionAdapter(this));
    jRadioButton2.setText("Word");
    jRadioButton2.addActionListener(new Frame1_jRadioButton2_actionAdapter(this));
    jRadioButton3.setText("DWord");
    jLabel3.setText("Copyright (c) 1997-2004 Hai Li, Zeal SoftStudio.");
    jLabel3.setBounds(new Rectangle(8, 232, 381, 23));
    jScrollPane1.setBounds(new Rectangle(9, 38, 275, 148));
    jList1.setMinimumSize(new Dimension(0, 0));
    jList1.setModel(model);
    jList1.setVisibleRowCount(8);
    contentPane.add(jLabel1, null);
    contentPane.add(jTextField1, null);
    contentPane.add(jLabel2, null);
    contentPane.add(jTextField2, null);
    contentPane.add(btnRead, null);
    contentPane.add(btnWrite, null);
    jPanel1.add(jRadioButton1, null);
    jPanel1.add(jRadioButton2, null);
    jPanel1.add(jRadioButton3, null);
    contentPane.add(jScrollPane1, null);
    jScrollPane1.getViewport().add(jList1, null);
    contentPane.add(jLabel3, null);
    contentPane.add(jPanel1, null);
    buttonGroup1.add(jRadioButton1);
    buttonGroup1.add(jRadioButton2);
    buttonGroup1.add(jRadioButton3);

  }
  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void jTextField1_actionPerformed(ActionEvent e) {

  }

  void btnWrite_actionPerformed(ActionEvent e) {
    int outNum;
    short portAdd;

    portAdd = Integer.valueOf(jTextField1.getText(), 16).shortValue();
    outNum = Integer.valueOf(jTextField2.getText(), 16).intValue();

    if(jRadioButton1.isSelected())
    {
            NTPortJava.Outport(portAdd, (short)outNum);
    }
    else if(jRadioButton2.isSelected())
    {
            NTPortJava.OutportW(portAdd, (short)outNum);
    }
    else
    {
            NTPortJava.OutportD(portAdd, (int)outNum);
    }

    model.addElement("Out 0x" + Integer.toHexString(portAdd)
                     + ", 0x" + Integer.toHexString(outNum));

    StringBuffer sError = new StringBuffer(255);
    NTPortJava.GetLastState(sError);
    model.addElement(sError.toString());
    jList1.ensureIndexIsVisible(model.getSize());

  }

  void jRadioButton2_actionPerformed(ActionEvent e) {

  }

  void jRadioButton1_actionPerformed(ActionEvent e) {

  }

  void btnRead_actionPerformed(ActionEvent e) {
    int inNum;
    short portAdd;

    portAdd = Integer.valueOf(jTextField1.getText(), 16).shortValue();

    if(jRadioButton1.isSelected())
    {
            inNum = (int)NTPortJava.Inport(portAdd);
    }
    else if(jRadioButton2.isSelected())
    {
            inNum = (int)NTPortJava.InportW(portAdd);
    }
    else
    {
            inNum = NTPortJava.InportD(portAdd);
    }

    model.addElement("In 0x" + Integer.toHexString(portAdd)
                     + ", 0x" + Integer.toHexString(inNum));

    StringBuffer sError = new StringBuffer(255);
    NTPortJava.GetLastState(sError);
    model.addElement(sError.toString());
    jList1.ensureIndexIsVisible(model.getSize() - 1);

  }
}

class Frame1_jTextField1_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jTextField1_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTextField1_actionPerformed(e);
  }
}

class Frame1_btnWrite_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_btnWrite_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnWrite_actionPerformed(e);
  }
}

class Frame1_jRadioButton2_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jRadioButton2_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jRadioButton2_actionPerformed(e);
  }
}

class Frame1_jRadioButton1_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jRadioButton1_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jRadioButton1_actionPerformed(e);
  }
}

class Frame1_btnRead_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_btnRead_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnRead_actionPerformed(e);
  }
}